#ifndef _ETHERNET_TX_H
#define _ETHERNET_TX_H

/* Ethernet */
#define ETX_E		PORTBbits.RB0
#define ETX_CLK		PORTBbits.RB1
#define ETX_DATA	PORTBbits.RB4
#define ETX_TRISB	0xEC

#define ETX_PAYLOAD_SIZE	46	/* minimum frame payload size as of 802.3 3.1.1 */
#define ETX_IP_HEADER_SIZE	20
#define ETX_UDP_HEADER_SIZE	8
#define ETX_DATA_SIZE		( ETX_PAYLOAD_SIZE - ETX_IP_HEADER_SIZE - ETX_UDP_HEADER_SIZE )
#define ETX_DATA_OFFSET		( ETX_IP_HEADER_SIZE + ETX_UDP_HEADER_SIZE )
#define ETX_UDP_DATAGRAM_SIZE	( ETX_UDP_HEADER_SIZE + ETX_DATA_SIZE )
#define ETX_FRAME_SIZE		( 8 + 14 + ETX_PAYLOAD_SIZE + 4 )

#define ETX_NLP_PERIOD		16 /* 16 ms normal link pulse period */

typedef union _ethernet_frame {
    struct {
      byte	pre[8];  /* preamble */
      byte	dst[6];  /* destination MAC */
      byte	src[6];  /* source MAC */
      byte	type[2]; /* type or size */
      byte	payload[ETX_PAYLOAD_SIZE];
      dword	crc;
    };
    byte	raw[ETX_FRAME_SIZE];
} ethernet_frame;

extern ethernet_frame etx_frame;

extern void etx_init( void );
extern void etx_send_data( void );
extern void etx_process( void ); /* call this every 1ms */

#endif
